
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <GL/gl.h>
#include <GL/glu.h>

#include "joueur.h"

Batte::Batte (Joueur *prop, int num):
  Item(0,-35,0,0,0)
{
  enableShoot=false;
  proprietaire=prop;
  longueur=longueurInit;
  
  bc.lX=longueur;
  bc.lY=1;
  bc.lZ=1;
    
  if(num == 1)
  {
    if( prop->getSide() == COTE_HAUT)
      position.Y=35;
  }
  else if (num == 2)
  {
    if( prop->getSide() == COTE_BAS)
      position.Y=-32;
    else if( prop->getSide() == COTE_HAUT)
      position.Y=35;
  }
}



void Batte::deplacer(int sens)
{
   if(sens > 0)
     position.X = position.X + pasDeplacement;
   else
     position.X = position.X - pasDeplacement;
  //verification de sortie du jeu ici ou plus loin?
}

void Batte::afficher ()
{
  float demieLongueur = longueur / 2;
  const float demieProfondeur = 0.5;
  const float demieHauteur = 0.5 ;
  const float canonDProf=0.4;
  const float canonDLong=0.8;
  const float canonDlarg=0.4;
  
  
  glPushMatrix();
  
  glTranslated(position.X, position.Y, 0); 
  
  glColor3ub(0, 255, 10);
  glBegin(GL_QUADS);
  
  glNormal3i(0,1,0);
  glVertex3d(demieLongueur, demieHauteur, demieProfondeur);
  glVertex3d(demieLongueur, demieHauteur, -demieProfondeur);
  glVertex3d(-demieLongueur, demieHauteur, -demieProfondeur);
  glVertex3d(-demieLongueur, demieHauteur, demieProfondeur);
  
  glNormal3i(0,0,1);
  glVertex3d(demieLongueur, demieHauteur, demieProfondeur);
  glVertex3d(-demieLongueur, demieHauteur, demieProfondeur);
  glVertex3d(-demieLongueur, -demieHauteur, demieProfondeur);
  glVertex3d(demieLongueur, -demieHauteur, demieProfondeur);
  
  glNormal3i(1,0,0);
  glVertex3d(demieLongueur, demieHauteur, demieProfondeur);
  glVertex3d(demieLongueur, -demieHauteur, demieProfondeur);
  glVertex3d(demieLongueur, -demieHauteur, -demieProfondeur);
  glVertex3d(demieLongueur, demieHauteur, -demieProfondeur);
  
  glNormal3i(0,0,-1);
  glVertex3d(demieLongueur, demieHauteur, -demieProfondeur);
  glVertex3d(demieLongueur, -demieHauteur, -demieProfondeur);
  glVertex3d(-demieLongueur, -demieHauteur, -demieProfondeur);
  glVertex3d(-demieLongueur, demieHauteur, -demieProfondeur);  
  
  glNormal3i(-1,0,0);
  glVertex3d(-demieLongueur, demieHauteur, -demieProfondeur);
  glVertex3d(-demieLongueur, -demieHauteur, -demieProfondeur);
  glVertex3d(-demieLongueur, -demieHauteur, demieProfondeur);
  glVertex3d(-demieLongueur, demieHauteur, demieProfondeur); 
  
  glNormal3i(0,-1,0);
  glVertex3d(demieLongueur, -demieHauteur, demieProfondeur);
  glVertex3d(-demieLongueur, -demieHauteur, demieProfondeur);
  glVertex3d(-demieLongueur, -demieHauteur, -demieProfondeur);
  glVertex3d(demieLongueur, -demieHauteur, -demieProfondeur);
  
  glEnd();
  
  
  if(enableShoot)
  {    
    glColor3ub(255, 255, 0);
    glTranslated(0, demieHauteur, demieProfondeur);
    glBegin(GL_QUADS);
    
    glNormal3i(0,1,0);
    glVertex3d(canonDlarg, canonDLong, canonDProf);
    glVertex3d(canonDlarg, canonDLong, -canonDProf);
    glVertex3d(-canonDlarg, canonDLong, -canonDProf);
    glVertex3d(-canonDlarg, canonDLong, canonDProf);
    
    glNormal3i(0,0,1);
    glVertex3d(canonDlarg, canonDLong, canonDProf);
    glVertex3d(-canonDlarg, canonDLong, canonDProf);
    glVertex3d(-canonDlarg, -canonDLong, canonDProf);
    glVertex3d(canonDlarg, -canonDLong, canonDProf);
    
    glNormal3i(1,0,0);
    glVertex3d(canonDlarg, canonDLong, canonDProf);
    glVertex3d(canonDlarg, -canonDLong, canonDProf);
    glVertex3d(canonDlarg, -canonDLong, -canonDProf);
    glVertex3d(canonDlarg, canonDLong, -canonDProf);
    
    glNormal3i(0,0,-1);
    glVertex3d(canonDlarg, canonDLong, -canonDProf);
    glVertex3d(-canonDlarg, canonDLong, -canonDProf);
    glVertex3d(-canonDlarg, -canonDLong, -canonDProf);
    glVertex3d(canonDlarg, -canonDLong, -canonDProf);
    
    glNormal3i(-1,0,0);
    glVertex3d(-canonDlarg, canonDLong, -canonDProf);
    glVertex3d(-canonDlarg, canonDLong, canonDProf);
    glVertex3d(-canonDlarg, -canonDLong, canonDProf);
    glVertex3d(-canonDlarg, -canonDLong, -canonDProf);
    
    glNormal3i(0,-1,0);
    glVertex3d(canonDlarg, -canonDLong, canonDProf);
    glVertex3d(canonDlarg, -canonDLong, -canonDProf);
    glVertex3d(-canonDlarg, -canonDLong, -canonDProf);
    glVertex3d(-canonDlarg, -canonDLong, canonDProf);
    glEnd();
  }
  
  glPopMatrix();
}
