/***************************************************************************
 *            batte.h
 *
 *  Thu Nov 22 10:15:35 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef H_CB_BATTE
#define H_CB_BATTE

#include "item.h"

typedef class Joueur;

class Batte:public Item
{
 private:
   float longueur;
   Joueur *proprietaire;
   BoiteCollision bc;
   bool enableShoot;

   static const float pasAgrandissement = 2.5;
   static const float pasDeplacement = 1;
   static const float longueurMax = 15;
   static const float longueurMin = 5;
   static const float longueurInit = 10;
  
  public:
    
    Batte (Joueur *prop, int num);
//  ~Batte ();
  
  inline BoiteCollision* getBoiteCol ()
  {
    return &bc;
  }
  
  inline void agrandir ()
  {
    if(longueur + pasAgrandissement <= longueurMax)
    {
      longueur = longueur + pasAgrandissement;
      bc.lX = bc.lX + pasAgrandissement;
    }
  }
  
  inline void reduire ()
  {
    if(longueur - pasAgrandissement >= longueurMin)
    {
      longueur = longueur - pasAgrandissement;
      bc.lX = bc.lX - pasAgrandissement;
    }
  }

  inline float getLongueur()
  {
    return longueur;
  }
  
  inline float getPasDep()
  {
    return pasDeplacement;
  }
  
  inline bool canShoot()
  {return enableShoot;}
  
  inline void putCanon()
  {enableShoot = true;}
  inline void removeCanon()
  {enableShoot = false;}
  
  void deplacer (int sens);
  
  void afficher ();
  
};

#endif
