/***************************************************************************
 *            bonus.cc
 *
 *  Tue Nov 27 14:17:07 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>

#include "bonus.h"

 Bonus::Bonus (float X,float Y,TypeBonus T,int sens):Item(X,Y,0,0,0)
{
   type = T;
   bc.lX=2;
   bc.lY=2;
   bc.lZ=2;
  
  sensChute = sens;
  
  glPushMatrix();
  
  glLoadIdentity();
  glRotatef((rand()%30)/3.0,(rand()%30)/3.0,(rand()%30)/3.0,1);
  glGetFloatv(GL_MODELVIEW_MATRIX, mRotation);
  
  glLoadIdentity();
  glGetFloatv(GL_MODELVIEW_MATRIX, mOrientation);
  
  glPopMatrix();
}

Bonus::~Bonus(){}

void  Bonus::afficher ()
{
  glPushMatrix();
  
  glTranslated(position.X, position.Y, position.Z);
  glMultMatrixf(mOrientation);
  
  switch(type)
  {
	case BONUS_RBATTE:
	  glColor3ub(255, 0, 0);
	  break;
	case BONUS_ABATTE:
	  glColor3ub(0, 255, 0);
	  break;
	case BONUS_LIFE:
	  glColor3ub(255, 255, 255);
	  break; 
	case BONUS_MULTIBALL:
	  glColor3ub(0, 50, 255);
	  break;
	case BONUS_BTRAVERSANTE:
	  glColor3ub(255, 0, 255);
	  break;
	case BONUS_ARME:
	  glColor3ub(255, 255 , 0);
	  break;
	case BONUS_ABALLE:
	  glColor3ub(0, 255, 255);
	  break;
	default:
	  std::cout << " bonus en bois" << std::endl;
	  break;
  }
  
  glScalef(0.7, 0.7, 0.7);
  glBegin(GL_QUADS);

    glNormal3i(0,1,0);
    glVertex3d(1, 1, 1);
    glVertex3d(1, 1, -1);
    glVertex3d(-1, 1, -1);
    glVertex3d(-1, 1, 1);
  
    glNormal3i(0,-1,0);
    glVertex3d(1, -1, 1);
    glVertex3d(-1, -1, 1);
    glVertex3d(-1, -1, -1);
    glVertex3d(1, -1, -1);
  
    glNormal3i(0,0,1);
    glVertex3d(1, 1, 1);
    glVertex3d(-1, 1, 1);
    glVertex3d(-1, -1, 1);
    glVertex3d(1, -1, 1);
  
    glNormal3i(0,0,-1);
    glVertex3d(1, 1, -1);
    glVertex3d(1, -1, -1);
    glVertex3d(-1, -1, -1);
    glVertex3d(-1, 1, -1);  
  
    glNormal3i(1,0,0);
    glVertex3d(1, 1, 1);
    glVertex3d(1, -1, 1);
    glVertex3d(1, -1, -1);
    glVertex3d(1, 1, -1);

    glNormal3i(-1,0,0);
    glVertex3d(-1, 1, -1);
    glVertex3d(-1, -1, -1);
    glVertex3d(-1, -1, 1);
    glVertex3d(-1, 1, 1);
    glEnd();
  
  glPopMatrix();
}
