/***************************************************************************
 *            bonus.h
 *
 *  Thu Nov 22 10:04:22 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef H_CB_BONUS
#define H_CB_BONUS

#include "item.h"
#include <iostream>

typedef enum TYPEBONUS
{
   BONUS_NONE=0,
   BONUS_LIFE,
   BONUS_ABATTE,
   BONUS_RBATTE,
   BONUS_MULTIBALL,
   BONUS_BTRAVERSANTE,
   BONUS_ABALLE,
   BONUS_ARME
   
} TypeBonus;

class Bonus:public Item
{
 private:
   TypeBonus type;
   BoiteCollision bc;
   int sensChute;
   GLfloat mRotation[16];
   GLfloat mOrientation[16];

   static const float vDescente = 0.2;
   
 public:

     Bonus (float X,float Y,TypeBonus,int sens);
    ~Bonus ();

   void afficher ();

   inline void deplacer()
   {
	 if(sensChute < 0)
	 	position.Y = position.Y - vDescente;
	 else
	   position.Y = position.Y + vDescente;
	 
	glPushMatrix();
  	glLoadIdentity();
  	glMultMatrixf(mOrientation);
  	glMultMatrixf(mRotation);
  	glGetFloatv(GL_MODELVIEW_MATRIX, mOrientation);
  	glPopMatrix();
   }

   inline TypeBonus getType ()
      {return type;}

   inline BoiteCollision* getBoiteCol()
      {return &bc;}

};

#endif
