
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <GL/gl.h>
#include <GL/glu.h>


#include "brique.h"

Brique::Brique(int solidite,float X, float Y):
Item(X,Y,0,0,0)
{
  ptsVie=solidite;
  bc.lX=demieLongX*2;
  bc.lY=demieLongY*2;
  bc.lZ=1;
}

void Brique::afficher()
{
    glPushMatrix();
    glTranslated(position.X, position.Y, position.Z);

  /*
  static float angle=0;
  angle = angle +0.01;
    glRotatef(angle,1,0,0);
  */
  if(ptsVie == -1)
    glColor3ub(120, 120, 120);
  else
    glColor3ub(230 - ptsVie * 7, (70+ptsVie*10) , (150 - ptsVie*2));
  
    glBegin(GL_QUADS);

    glNormal3i(0,1,0);	//dessus
    glVertex3d(1.5, 1, 0.3);
    glVertex3d(1.5, 1, -0.3);
    glVertex3d(-1.5, 1, -0.3);
    glVertex3d(-1.5, 1, 0.3);
  
    glNormal3i(0,-1,0); //dessous
    glVertex3d(1.5, -1, 0.3);
    glVertex3d(-1.5, -1, 0.3);
    glVertex3d(-1.5, -1, -0.3);
    glVertex3d(1.5, -1, -0.3);
  
    glNormal3i(1,0,0); //droite
    glVertex3d(2, 0.6, 0.3);
    glVertex3d(2, -0.6, 0.3);
    glVertex3d(2, -0.6, -0.3);
    glVertex3d(2, 0.6, -0.3);  
  
    glNormal3i(-1,0,0);  //gauche
    glVertex3d(-2, 0.6, -0.3);
    glVertex3d(-2, -0.6, -0.3);
    glVertex3d(-2, -0.6, 0.3);
    glVertex3d(-2, 0.6, 0.3);
  
    glNormal3i(0,0,1);//devant
    glVertex3d(1.5, 0.6, 0.5);
    glVertex3d(-1.5, 0.6, 0.5); 
    glVertex3d(-1.5, -0.6, 0.5);
    glVertex3d(1.5, -0.6, 0.5);	
  
	 glNormal3i(0,0,-1); //derriere
    glVertex3d(1.5, 0.6, -0.5);
    glVertex3d(1.5, -0.6, -0.5);
    glVertex3d(-1.5, -0.6, -0.5);
    glVertex3d(-1.5, 0.6, -0.5);
  
    glNormal3i(0,1,1); //avant haut
    glVertex3d(1.5, 0.6, 0.5);
    glVertex3d(1.5, 1, 0.3);
    glVertex3d(-1.5, 1, 0.3);  
    glVertex3d(-1.5, 0.6, 0.5); 
  
    glNormal3i(0,-1,1); //Avant bas
    glVertex3d(1.5, -0.6, 0.5);
    glVertex3d(-1.5, -0.6, 0.5);
    glVertex3d(-1.5, -1, 0.3);
    glVertex3d(1.5, -1, 0.3);
  
    glNormal3i(1,0,1); //avant droit
    glVertex3d(1.5, -0.6, 0.5);
    glVertex3d(2, -0.6, 0.3); 
    glVertex3d(2, 0.6, 0.3);
    glVertex3d(1.5, 0.6, 0.5);
  
    glNormal3i(-1,0,1); //avant gauche
    glVertex3d(-1.5, -0.6, 0.5);
    glVertex3d(-1.5, 0.6, 0.5);
    glVertex3d(-2, 0.6, 0.3);
    glVertex3d(-2, -0.6, 0.3);
  
    glNormal3i(0,1,-1); //arriere haut
    glVertex3d(1.5, 0.6, -0.5);
    glVertex3d(-1.5, 0.6, -0.5);
    glVertex3d(-1.5, 1, -0.3);
    glVertex3d(1.5, 1, -0.3);  
  
    glNormal3i(0,-1,-1); //arriere bas
    glVertex3d(1.5, -0.6, -0.5);
    glVertex3d(1.5, -1, -0.3);
    glVertex3d(-1.5, -1, -0.3);
    glVertex3d(-1.5, -0.6, -0.5); 
  
    glNormal3i(1,0,-1); //arriere droit
    glVertex3d(1.5, -0.6, -0.5);
    glVertex3d(1.5, 0.6, -0.5);
    glVertex3d(2, 0.6, -0.3);
    glVertex3d(2, -0.6, -0.3);
  
    glNormal3i(-1,0,-1); //arriere gauche
    glVertex3d(-1.5, -0.6, -0.5);
    glVertex3d(-2, -0.6, -0.3);
    glVertex3d(-2, 0.6, -0.3);
    glVertex3d(-1.5, 0.6, -0.5);

    glNormal3i(-1,1,0); //haut gauche
    glVertex3d(-2, 0.6, 0.3);
    glVertex3d(-1.5, 1, 0.3);
    glVertex3d(-1.5, 1, -0.3);
    glVertex3d(-2, 0.6, -0.3);  
  
    glNormal3i(-1,-1,0); //bas gauche
    glVertex3d(-2, -0.6, 0.3);
    glVertex3d(-2, -0.6, -0.3);
    glVertex3d(-1.5, -1, -0.3);
    glVertex3d(-1.5, -1, 0.3);
  
    glNormal3i(1,1,0); //haut droit
    glVertex3d(2, 0.6, 0.3);
    glVertex3d(2, 0.6, -0.3);
    glVertex3d(1.5, 1, -0.3);
    glVertex3d(1.5, 1, 0.3);
  
    glNormal3i(1,-1,0); //bas droit
    glVertex3d(2, -0.6, 0.3);
    glVertex3d(1.5, -1, 0.3);
    glVertex3d(1.5, -1, -0.3);
    glVertex3d(2, -0.6, -0.3);
  
    glEnd();
	glBegin(GL_TRIANGLES);

  //coins

	glNormal3i(-1,1,1);
    glVertex3d(-2, 0.6, 0.3);
    glVertex3d(-1.5, 0.6, 0.5);
    glVertex3d(-1.5, 1, 0.3);
  
	glNormal3i(1,1,1);
    glVertex3d(2, 0.6, 0.3);
    glVertex3d(1.5, 1, 0.3);
    glVertex3d(1.5, 0.6, 0.5);
  
	glNormal3i(-1,-1,1);
    glVertex3d(-2, -0.6, 0.3);
    glVertex3d(-1.5, -1, 0.3);
    glVertex3d(-1.5, -0.6, 0.5);
  
	glNormal3i(1,-1,1);
    glVertex3d(2, -0.6, 0.3);
    glVertex3d(1.5, -0.6, 0.5);
    glVertex3d(1.5, -1, 0.3);
  
	glNormal3i(-1,1,-1);
    glVertex3d(-2, 0.6, -0.3);
    glVertex3d(-1.5, 1, -0.3);
    glVertex3d(-1.5, 0.6, -0.5);
  
	glNormal3i(1,1,-1);
    glVertex3d(2, 0.6, -0.3);
    glVertex3d(1.5, 0.6, -0.5);
    glVertex3d(1.5, 1, -0.3);

	glNormal3i(-1,-1,-1);
    glVertex3d(-2, -0.6, -0.3);
    glVertex3d(-1.5, -0.6, -0.5);
    glVertex3d(-1.5, -1, -0.3);

	glNormal3i(1,-1,-1);
    glVertex3d(2, -0.6, -0.3);
    glVertex3d(1.5, -1, -0.3);
    glVertex3d(1.5, -0.6, -0.5);
  
	glEnd();

    glPopMatrix();
}
