/***************************************************************************
 *            brique.h
 *
 *  Thu Nov 22 10:46:18 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#ifndef H_CB_BRIQUE
#define H_CB_BRIQUE

#include "item.h"

class Brique: public Item
{
   private:
   int ptsVie;
   BoiteCollision bc;

   public:

  static const float demieLongX=2;
  static const float demieLongY=1;

   Brique(int solidite,float X, float Y);
//   ~Brique();

   //renvoie true si il faut detruire la brique, false sinon
   inline bool faireDegats(int n)
   {
      if(ptsVie >= 1)
      {
         ptsVie = ptsVie - n;
         if(ptsVie <= 0)
         {
            return true;
         }
         else
            return false;
      }
      else
         return false;
   }
   
  inline BoiteCollision* getBoiteCol ()
  {
    return &bc;
  }

  inline static float getDemieLongX()
  {return demieLongX;}
  inline static float getDemieLongY()
  {return demieLongY;}

   void afficher();

};

#endif
