/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>

#include <stdio.h>

#include "debris.h"

Debris::Debris (Vecteur pos, unsigned char R,unsigned char V,unsigned char B):
Item(pos,0,0,0)
{
  
  vitesse.X=(rand()%15-7.5)/10;
  vitesse.Y=(rand()%15-7.5)/10;
  vitesse.Z=(rand()%15-7.5)/10;
  
  bc.lX=(float)(rand()%20)/18.;
  bc.lY=(float)(rand()%20)/20.;
  bc.lZ=0;
  
  if(R+V+B == 0)
  {
	cR=rand()%256;
	cV=rand()%256;
	cB=rand()%256;
  }
  else
  {
  	cR=R;
  	cV=V;
  	cB=B;
  }
  
  dateCreation = SDL_GetTicks();
    
  glPushMatrix();
  
  glLoadIdentity();
  glRotatef((rand()%30)/3.0,(rand()%30)/3.0,(rand()%30)/3.0,1);
  glGetFloatv(GL_MODELVIEW_MATRIX, mRotation);
  
  glLoadIdentity();
  glGetFloatv(GL_MODELVIEW_MATRIX, mOrientation);
  
  glPopMatrix();
}

void Debris::afficher()
{
  
  float width = bc.lX;
  float height= bc.lY;
  
  glPushMatrix();
  
  glTranslated(position.X, position.Y, position.Z);
  glMultMatrixf(mOrientation);
  
  //faire un truc pour recup la couleur de la brique quand elle est detruite
  //glColor3ub(230, 130, 120);
  glColor3ub(cR,cV,cB);
  
  glBegin(GL_QUADS);
  
  glNormal3i(0,0,1);	
  glVertex3d(width, height, 0);
  glVertex3d(-width, height, 0);
  glVertex3d(-width, -height, 0);
  glVertex3d(width, -height, 0);
  
  glEnd();
  
  glPopMatrix();
}

void Debris::deplacer()
{
  vitesse.Y -= gravite;
  position.X += vitesse.X;
  position.Y += vitesse.Y;
  position.Z += vitesse.Z;
  
  //rebonds sur les bords, a traiter ailleurs probablement
  if(position.X<= -40 || position.X >= 40)
    vitesse.X = -vitesse.X;
  
  glPushMatrix();
  glLoadIdentity();
  glMultMatrixf(mOrientation);
  glMultMatrixf(mRotation);
  glGetFloatv(GL_MODELVIEW_MATRIX, mOrientation);
  glPopMatrix();
}
