/***************************************************************************
 *            debris.h
 *
 *  Thu Nov 22 10:35:14 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef H_CB_DEBRIS
#define H_CB_DEBRIS

#include "item.h"
#include <SDL/SDL.h>

class Debris:public Item
{
 private:
   int dateCreation;
   GLfloat mRotation[16];
   GLfloat mOrientation[16];
   BoiteCollision bc;
   Vecteur vitesse;
  unsigned char cR,cV,cB;

   static const float gravite = 0.02;
  static const float lifeTime = 100000;
  
 public:
    Debris (Vecteur pos, unsigned char R=0,unsigned char V=0,unsigned char B=0);
//  ~Debris ();
  
  inline BoiteCollision *getBoiteCol ()
  {
    return &bc;
  }
  
  inline bool isTooOld()
  {
    if(SDL_GetTicks() - dateCreation >lifeTime)
      return true;
    else
      return false;
  }
  
  void afficher();
  void deplacer();
};

#endif
