/***************************************************************************
 *            display.cc
 *
 *  Tue Nov 27 15:04:56 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "display.h"

void HUD::traceCadres(int cadre[4])
{   
  glBegin(GL_LINES);
        glVertex2f(cadre[0], cadre[2]);
        glVertex2f(cadre[1], cadre[2]);
  
        glVertex2f(cadre[0], cadre[2]-font_size-5);
        glVertex2f(cadre[1], cadre[2]-font_size-5);
        glVertex2f(cadre[0], cadre[2]-font_size-8);
        glVertex2f(cadre[1], cadre[2]-font_size-8);
  
        glVertex2f(cadre[0], cadre[2]-2*font_size-12);
        glVertex2f(cadre[1], cadre[2]-2*font_size-12);
  
        glVertex2f(cadre[0], cadre[3]);
        glVertex2f(cadre[1], cadre[3]);
  
        glVertex2f(cadre[1], cadre[2]);
        glVertex2f(cadre[1], cadre[3]);
  
        glVertex2f(cadre[0], cadre[2]);
        glVertex2f(cadre[0], cadre[3]);
      glEnd();
}

void dessinerRepere(unsigned int echelle = 1)
{
    glPushMatrix();
    glScalef(echelle, echelle, echelle);
    glBegin(GL_LINES);

    glColor3ub(255, 0, 0);      //X en rouge
    glVertex3d(0, 0, 0);
    glVertex3d(1, 0, 0);

    glColor3ub(0, 255, 0);      //Y en vert
    glVertex3d(0, 0, 0);
    glVertex3d(0, 1, 0);

    glColor3ub(0, 0, 255);      //Z en bleu
    glVertex3d(0, 0, 0);
    glVertex3d(0, 0, 1);

    glEnd();
    glPopMatrix();
}

void dessinerBord()
{
    glPushMatrix();
    glBegin(GL_LINES);

    glColor3ub(255, 255, 0);

    glVertex3d(-40, 35, 0);     //dessus
    glVertex3d(40, 35, 0);

    glVertex3d(-40, -40, 0);    //a gauche
    glVertex3d(-40, 35, 0);

    glVertex3d(40, -40, 0);     //a droite
    glVertex3d(40, 35, 0);
  
    glVertex3d(-40, -40, 0);     //bas
    glVertex3d(40, -40, 0);

    glEnd();
    glPopMatrix();
}

HUD::HUD ()
{
  posXHUD=650;
  posYHUD=0;
  
  lX=150;
  lY=600;
  
  //coins haut gauche des cadres des joueurs;
  posJ1[0]=0;
  posJ1[1]=540;
  
  posJ2[0]=0;
  posJ2[1]=400;
  
  posNumNiveau[0]=5;
  posNumNiveau[1]=200;
  
  font_size=16;
  font.init("AXAXAX.TTF", font_size);
  
 // J1 = NULL;
  //J2 = NULL;
}

void HUD::affichage ()
{
  
  int cadreJ1[4];
  int cadreJ2[4];
  int longCadre;
  int largCadre;
  
   glDisable(GL_LIGHTING);
   glDisable(GL_DEPTH_TEST);
  
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(0, lX, 0, lY);

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   glColor3f(0.8, 0.8, 0);
  
  longCadre = 120 ;
  largCadre = -100;
    
  cadreJ1[0]=posJ1[0];
  cadreJ1[1]=posJ1[0] + longCadre ;
  cadreJ1[2]=posJ1[1];
  cadreJ1[3]=posJ1[1] + largCadre;
  
  cadreJ2[0]=posJ2[0];
  cadreJ2[1]=posJ2[0] + longCadre;
  cadreJ2[2]=posJ2[1];
  cadreJ2[3]=posJ2[1] + largCadre;
  
  traceCadres(cadreJ1);
  traceCadres(cadreJ2);
  
  //bricole pour pouvoir afficher le texte quand meme
  glViewport(0, 0,800, 600);
  glTranslatef(posXHUD,posYHUD,0);
  
     glColor3f(1, 1, 0);
   //affiche les scores
	freetype::print(font, cadreJ1[0]+font_size, cadreJ1[2]-font_size, "Joueur 1");
	freetype::print(font, cadreJ2[0]+font_size, cadreJ2[2]-font_size, "Joueur 2");
  
  
     glColor3f(0.8, 0.8, 0);
   //affiche les vies restantes
	print(font, cadreJ1[0]+font_size, cadreJ1[2]-2*(font_size)-7, "Battes: %d",J1->getNbVie());
  print(font, cadreJ2[0]+font_size, cadreJ2[2]-2*(font_size)-7, "Battes: %d",J2->getNbVie());
   
  print(font, cadreJ1[0]+font_size+12, cadreJ1[2]-4*(font_size)-13, "%6d",J1->getScore());
  print(font, cadreJ2[0]+font_size+12, cadreJ2[2]-4*(font_size)-13, "%6d",J2->getScore());

   //affiche le numero du niveau
	freetype::print(font, posNumNiveau[0], posNumNiveau[1], "Niveau 00");
  
  glEnable(GL_LIGHTING);  	// Active l'éclairage
  glEnable(GL_DEPTH_TEST);
}

Disposition::Disposition(Partie *partie,int fX,int fY,int tfX,int tfY):
partieEnCours(partie)
{
  posFenetre[0]=fX;
  posFenetre[1]=fY;
  
  tailleFenetre[0]=tfX;
  tailleFenetre[1]=tfY;
}

void Disposition::initFrame()
{
   //nettoyer le buffer
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   //passer dans le viewport du HUD
//  glViewport(0, 0,800, 600);

   glViewport(hudDisplay.posXHUD, hudDisplay.posYHUD, hudDisplay.lX, hudDisplay.lY);

   //afficher le HUD
   hudDisplay.affichage();

   //passer dans le viewport du jeu
   glViewport(posFenetre[0], posFenetre[1], tailleFenetre[0], tailleFenetre[1]);

   glMatrixMode(GL_PROJECTION);        //affichage en projection orthogonale

   glLoadIdentity();
   gluPerspective(60, (double) 4 / 3, 0.1, 1000);     //fov, ratio, near, far
   gluLookAt(0, 0, 70, 0, 0, 0, 0, 1, 0);
  
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
  
  // dessinerRepere(10);
   dessinerBord();
  
    GLfloat blanc[4] = { 10.0, 10.0, 10.0, 1.0 };
//    GLfloat jaune[4] = { 7.0, 7.0, 0.0, 1.0 };
    GLfloat position0[4] ={0.0,0.0,20.0,1.0};

    glLightfv(GL_LIGHT0, GL_AMBIENT, blanc);
    glLightfv(GL_LIGHT0, GL_DIFFUSE,  blanc );
    glLightfv(GL_LIGHT0, GL_SPECULAR,  blanc);
    glLightfv(GL_LIGHT0, GL_POSITION, position0);
    glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 1.1);

  //lumiere des balles a gerer, attention a la limite a 7 lumieres
  /*
    GLfloat position1[4] ={balle.x,balle.y,balle.z,1.0};
    glLightfv(GL_LIGHT1, GL_DIFFUSE,  jaune);
    glLightfv(GL_LIGHT1, GL_POSITION, position1);
    glLightf(GL_LIGHT1, GL_LINEAR_ATTENUATION, 1.3);
  */
}

void Disposition::initAffichage ()
{
/**************** partira dans Disposition::initAffichage() **************/
    //init opengl
    glEnable(GL_DEPTH_TEST);    //test de profondeur
    glEnable(GL_LIGHTING);  	// Active l'éclairage
    glEnable(GL_NORMALIZE);     // Prends en compte la normale des polygones
    glEnable(GL_COLOR_MATERIAL);//la couleur des polygones est utilisée pour les effets de lumiere
    glEnable(GL_CULL_FACE);
    glCullFace(GL_BACK);
  
    glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);

    glEnable(GL_LIGHT0); //lampe globale
    glEnable(GL_LIGHT1); //lampe balle

    glMateriali(GL_FRONT, GL_SHININESS, 50);

/***************************************************************************/
}
