/***************************************************************************
 *            display.h
 *
 *  Thu Nov 22 11:05:07 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef H_CB_DISPLAY
#define H_CB_DISPLAY

#include "FreeType.h"
#include "joueur.h"

typedef class Partie;

class HUD
{
  friend class Disposition;
 private:

   int posXHUD;
   int posYHUD;

   int lX;
   int lY;

   int posNumNiveau[2];
  
   int posJ1[2];
   int posJ2[2];

   int font_size;
   freetype::font_data font;
  
   Joueur *J1;
   Joueur *J2;

  void traceCadres(int cadre[4]);
 public:
     HUD ();
    ~HUD ()
  {
      //font.clean();
  }
  
  inline void setJoueur(Joueur *J,int num)
  {
    if(num == 1)
      J1 = J;
    else if (num ==2)
      J2 = J;
    else
      return;
  }
 
   void affichage ();
};

class Disposition
{
 private:

   //position et taille du cadre de dessin de la scene
   int posFenetre[2];
   int tailleFenetre[2];

   //informations diverses
   HUD hudDisplay;

   //utile pour acceder au nombre de joueurs
   Partie *partieEnCours;

 public:
   Disposition(Partie *partie,int fX,int fY,int tfX,int tfY);
   void initFrame();
   void initAffichage();
 
  inline void setJoueur(Joueur *J,int num)
  {
    hudDisplay.setJoueur(J,num);
  }
  
};

#endif
