/***************************************************************************
 *            joueur.h
 *
 *  Thu Nov 24 11:05:07 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef H_CB_JOUEUR
#define H_CB_JOUEUR

#include <SDL/SDL.h>
#include "batte.h"

class Joueur
{
  private:
    int score;
    int vies;
    Batte batte;
    int nBalles;
    Side side;
  
    bool destoyed;
    unsigned int destructTime;
  
    static const unsigned int recoverTime = 3000;
  
  public:
    Joueur(int num):batte(this,num)
    {
      score=0;
      vies=3;
      nBalles=0;
      destoyed=false;
      destructTime=0;
    }
  
    inline void ajouterScore(int points)
    {
       score = score + points;
    }

    inline void ajouterVie()
    {
       vies++;
    }

    inline void afficher()
    {
      if(!destoyed)
        batte.afficher();
    }
  
    inline void addBalle()
    { nBalles++;}
    inline void rmBalle()
    { nBalles--;}
    inline int getnBalles()
    { return nBalles;}
  
  inline void deplacer (int sens)
  {
    batte.deplacer (sens);
  }
  
    inline Batte& getBatteRef()
    {
      return batte;
    }
  
    inline int getNbVie()
    {
       return vies;
    }
    
    inline Side getSide()
    {
      return side;
    }
    inline int getScore()
    { return score;}
    
    inline void perteVie()
    {
       vies--;
    }
    
    inline void setSide(Side cote)
    {
      side = cote;
    }
  
    inline void destroy()
    {
      destoyed=true;
      destructTime=SDL_GetTicks();
    }
  
    inline bool isDestroyed()
    {
      return destoyed;
    }
  
    inline bool hasRecovered()
    {
      if(SDL_GetTicks() - destructTime > recoverTime)
        return true;
      else
        return false;
    }
  
    inline void recover()
    {
      destoyed=false;
    }
};

#endif
