/***************************************************************************
 *            Menu
 *
 *  Tue Dec  4 09:59:51 2007
 *  Copyright  2007  MUZI Jean-Marc
 *  jean-marc.muzi@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <string>

using namespace std;

class Menu
{
  GLuint imageTitre;
  float posXHGMenu; //Coin haut gauche du menu : X
  float posYHGMenu; //et Y
  float posXBDMenu; //Coin bas droite du menu : X
  float posYBDMenu; //et Y
  const static float margin = 5;
  const static float hauteurlettres = 26;
  int idMenu;
  string title;
  string *labels;
  int nbLabels;
  int currentChoice;
   freetype::font_data our_font;
  void reinit (string ititle, string * listChoices, int nbChoices, int id); //reinit de la liste des items du menu
  void initMenu (string ititle, string * listChoices, int nbChoices, int id); //Initialisation simple sans desaffectation
public:
    Menu (float XHG, float YHG, float XBD, float YBD);
   ~Menu ();
  void initDisplay(); //Initialisation de l'affichage du menu
  void reinitMainMenu(); //Reinitialisation du menu principal
  void reinitPartieType();
  void reinitOptionsMenu();
  void reinitControlesMenu();
  void reinitFullscreen();
  void reinitSoundMenu();
  void nextChoice(); //Selection du choix suivant
  void precChoice(); //Selection du choix precedent
  void activateChoice(); //Gestion lorsque la touche entree est appuyee
  void display (); //Rafraichissement du dessin du menu
};
