/***************************************************************************
 *            niveau.h
 *
 *  Thu Nov 24 19:45:07 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef H_CB_NIVEAU
#define H_CB_NIVEAU
//using namespace std;

#include "brique.h"
#include <string>

class Niveau
{
  friend class Partie;
  
  public:

  static const int nbBriquesX = 16;
  static const int nbBriquesY = 10;
  
  Niveau(float briquesY);
  ~Niveau();
  void initBriques(const char* fichier,int nNiveau);
  
  inline int nbBriquesRestantes ()
  {return qBriques;}
  
  inline int getNumNiveau()
  {return numNiveau;}

  inline float getPosBriquesX()
  {return posBriquesX;}

  inline float getPosBriquesY()
  {return posBriquesY;}

  inline float getEcartX()
  {return ecartX;}
  
  inline float getEcartY()
  {return ecartY;}

  Brique *tabBriques[nbBriquesX][nbBriquesY];
  
  private:

  static const float tailleX = 600;
  static const float tailleY = 600;
  
  float posBriquesX;
  float posBriquesY;
  static const float ecartX = 4.6;
  static const float ecartY = 2.4;
  
  int numNiveau;
  int qBriques;
  
  void detruire (int i, int j);
  
  void defaultLevel(); //niveau bidon en cas de manque de fichier .lvl
};

#endif
