
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
#include <stdlib.h>

#include "tir.h"


Tir::Tir (Joueur *prop,float X, float Y,bool goDown):
Item(X,Y,0,0,0)
{
  proprietaire=prop;  
  goingDown=goDown;
 
  quadric = gluNewQuadric();       //création du quadrique
  gluQuadricTexture(quadric, GL_TRUE); //activation des coordonnées de texture
}

Tir::~Tir()
{
    gluDeleteQuadric(quadric);   //je supprime le quadrique
}

void Tir::afficher ()
{ 
  glPushMatrix();
  
  //couleurs
  GLfloat jaune[4] = { 0.4, 0.4, 0.0,0.5};
  GLfloat rien[4]={0.0,0.0,0.0,0.0};
  glMaterialfv(GL_FRONT,GL_EMISSION,jaune); //lampe jaune dans la balle
  
  glColor3ub(200, 200, 200);
  
  glTranslated(position.X, position.Y, position.Z); //position dans le niveau
  
  gluSphere(quadric, rayon, 5, 5);
  
  //mess cleanup
  glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,rien);
  
  glPopMatrix();
}
