/***************************************************************************
 *            balle.h
 *
 *  Thu Nov 22 09:44:58 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef H_CB_BALL
#define H_CB_BALL

#include "item.h"
#include "joueur.h"

class Tir:public Item
{
  private:
  Joueur *proprietaire;
  GLUquadric *quadric;
  bool goingDown;
  
  static const float rayon = 0.2;
  static const float vitesse = 0.9;
  
  public:
    
    Tir (Joueur *prop,float X, float Y,bool goDown);
  ~Tir ();
  
  inline Joueur *getProp ()
  {return proprietaire;}
  
  void afficher ();

  inline void deplacer ()
  {
    if(goingDown)
      position.Y = -vitesse + position.Y;
    else
      position.Y = vitesse + position.Y;
  } 
  
  inline float getRayon ()
  { return rayon;}
  
  inline bool isGoingDown()
  {
    return goingDown;
  }

  inline float getVitesse()
  {
    return vitesse;
  }
  
};

#endif
