/***************************************************************************
 *            typesparties.cc
 *
 *  Tue Nov 27 15:23:55 2007
 *  Copyright  2007  Daniel CALECA
 *  daniel.caleca@etumel.univmed.fr
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "typesparties.h"
#include <math.h>
#include <iostream>

#include "mixer.h"
#include "bonus.h"
#include "partie.h"

extern AudioMixer amixer;

//utiliser les Partie::eventCollision pour renvoyer les bonnes actions

Normal1j::Normal1j ():Partie (1, 0, COTE_BAS, COTE_BAS)
{
}

void Normal1j::newBonus(float X, float Y, int sens)
{
  /*
  const int BONUS_LIFE_PROP = 2;
  const int  BONUS_ABATTE_PROP = 25;
  const int  BONUS_RBATTE_PROP = 25;
  const int  BONUS_MULTIBALL_PROP = 20;
  const int  BONUS_BTRAVERSANTE_PROP = 10;
  const int  BONUS_ABALLE_PROP = 10;
  const int  BONUS_ARME_PROP = 8;
  */
  const int BONUS_LIFE_PROP = 0;
  const int  BONUS_ABATTE_PROP = 0;
  const int  BONUS_RBATTE_PROP = 0;
  const int  BONUS_MULTIBALL_PROP = 100;
  const int  BONUS_BTRAVERSANTE_PROP = 0;
  const int  BONUS_ABALLE_PROP = 0;
  const int  BONUS_ARME_PROP = 0;
  
   int tmp = rand() % 100;
   int total= 0;
   bool choisit = false;
   TypeBonus type= BONUS_NONE;
  
   total += BONUS_LIFE_PROP;
   if(tmp < total && choisit == false)
   {
	  choisit=true;
      type = BONUS_LIFE;
   }

   total +=  BONUS_ABATTE_PROP;
   if(tmp < total && choisit == false)
   {
	  choisit=true;
      type = BONUS_ABATTE;
   }

   total +=  BONUS_RBATTE_PROP;
   if(tmp < total && choisit == false)
   {
	  choisit=true;
      type = BONUS_RBATTE;
   }

   total +=  BONUS_MULTIBALL_PROP;
   if(tmp < total && choisit == false)
   {
	  choisit=true;
      type = BONUS_MULTIBALL;
   }

   total +=  BONUS_BTRAVERSANTE_PROP;
   if(tmp < total && choisit == false)
   {
	  choisit=true;
      type = BONUS_BTRAVERSANTE;
   }

   total +=  BONUS_ABALLE_PROP;
   if(tmp < total && choisit == false)
   {
	  choisit=true;
      type = BONUS_ABALLE;
   }

   total +=  BONUS_ARME_PROP;
   if(tmp < total && choisit == false)
   {
	  choisit=true;
      type = BONUS_ARME;
   }

  	listeBonus.push_back (*new Bonus(X,Y,type,sens));
}

/*
1 joueur en bas de l'ecran
collision:
   balle - brique: degats sur la brique
   balle - balle: rebond des 2 balles
   balle - batte: rebond dependant du point d'impact
   debris - *: rien

verifier les sorties sur les bords
compter les points

gerer les effets des bonus
*/
void
Normal1j::verifPositions ()
{
  //bool temoin;
  int i, j;
  std::list < Balle >::iterator itBalles;
  std::list < Balle >::iterator itrmBalles;
  std::list < Bonus >::iterator itBonus;
  std::list < Bonus >::iterator itrmBonus;
  
  Vecteur norm;
  //float tmp=0;
  int newDebris=0;
  float rayon=0;
  float angle=0;
  
  
  if(joueur1.isDestroyed())
  {
    if(joueur1.hasRecovered() && joueur1.getNbVie() > 0)
    {
      joueur1.perteVie();
      joueur1.recover();
      newBall(&joueur1,true);
    }
    else if(joueur1.getNbVie() <= 0)
    { //fin de la partie pour J1
      
    }
  }
  
  //collisions de la balle
  for (itBalles = listeBalles.begin (); itBalles != listeBalles.end ();)
  {
    rayon = itBalles->getRayon();
    
    //test de collision avec le bord
    if(itBalles->getPosition()->X < -40 + itBalles->getRayon()) //cote gauche
    {
      norm.X=1;
      norm.Y=0;
      norm.Z=0;
      itBalles->undoDeplacer();
      itBalles->collision (norm);
      amixer.SPlay_LesserHit();
      itBalles->deplacer();
    }
    else if(itBalles->getPosition()->X + itBalles->getRayon() > 40) //cote droit
    {
      norm.X=-1;
      norm.Y=0;
      norm.Z=0;
      itBalles->undoDeplacer();
      itBalles->collision (norm);
      amixer.SPlay_LesserHit();
      itBalles->deplacer();
    }
    else if(itBalles->getPosition()->Y + itBalles->getRayon() > 35 ) //cote haut
    {
      norm.X=0;
      norm.Y=-1;
      norm.Z=0;
      itBalles->undoDeplacer();
      itBalles->collision (norm);
      amixer.SPlay_LesserHit();
      itBalles->deplacer();
    }
    
    //test de collision avec les briques, a optimiser plus tard
    //calcul des indices des briques a tester
    int iFirst, iLast;
    int jFirst, jLast;
    
    //premier: ecart (limite gauche de la balle > limite droite de la premiere brique) / ecart briques
    iFirst = (((int)((itBalles->getPosition()->X - rayon) - (niveauCourant.getPosBriquesX() + Brique::demieLongX)))
              / (int) niveauCourant.getEcartX()) -1;
    if(iFirst < 0)
      iFirst = 0;
    else if (iFirst > niveauCourant.nbBriquesX)
      iFirst = niveauCourant.nbBriquesX -1;
    
    iLast = (((int)((itBalles->getPosition()->X + rayon) - (niveauCourant.getPosBriquesX() - Brique::demieLongX)))
             / (int) niveauCourant.getEcartX()) + 1;
    if(iLast <= 0)
      iLast = 1;
    else if (iLast > niveauCourant.nbBriquesX)
      iLast = niveauCourant.nbBriquesX;
    
    jFirst = (((int) ((itBalles->getPosition()->Y - rayon) - (niveauCourant.getPosBriquesY() + Brique::demieLongY)))
              / (int) niveauCourant.getEcartY()) - 1 ;
    if(jFirst < 0)
      jFirst = 0;
    else if (jFirst > niveauCourant.nbBriquesY)
      jFirst = niveauCourant.nbBriquesY - 1;
    
    jLast = (((int)((itBalles->getPosition()->Y + rayon) - (niveauCourant.getPosBriquesY() - Brique::demieLongY)))
             / (int) niveauCourant.getEcartY()) + 1;
    if(jLast <= 0)
      jLast = 1;
    else if (jLast > niveauCourant.nbBriquesY)
      jLast = niveauCourant.nbBriquesY ;
    
    //std::cout << " X:" << iFirst << "-" << iLast << " Y:" << jFirst << "-" << jLast << std::endl;
    
    for (i = iFirst; i < iLast; i++)
      //for (i = 0; i < niveauCourant.nbBriquesX; i++)  
    {
      for (j = jFirst; j < jLast; j++)
        //for (j = 0; j < niveauCourant.nbBriquesY; j++)
      {
        if(niveauCourant.tabBriques[i][j] != NULL)
        {
          if (eventCollision
              (*(niveauCourant.tabBriques[i][j]),
               *itBalles))
          {
            //std::cout << "collision sur la brique: " << i << "-" << j << std::endl;
            //rebond
            /*
            tmp = sqrt( powf(norm.X,2) + powf(norm.Y,2) );
            norm.X = norm.X / tmp;
            norm.Y = norm.Y / tmp;
            */
            // 4/12: rebond perpendiculaire systematique
            
            //sol1:            
            //if (fabs(norm.X) <= 2) //bug: bloque dans le coin des briques
            //complete avec la solution precedente
            
            //sol2: frappe dans le coin comprise, y compris dans le sens X
            //foireux, se base sur un epsilon
            //if (fabs(norm.Y) - rayon >= 1 - fabs(itBalles->getVitesse()->Y))
            
            //problemes avec les coins
            /*
            itBalles->undoDeplacer();
            
            if (fabs(norm.X) <= 2 + rayon)
            {
            std::cout << " rebond sur Y "<< std::endl;
            norm.X=0;
            if(norm.Y > 0)
            norm.Y=1;
            else
            norm.Y=-1;
            itBalles->collision(norm);
            }
            else if (fabs(norm.Y) <= 1 + rayon)
            {
            std::cout << " rebond sur X "<< std::endl;
            norm.Y=0;
            if(norm.X > 0)
            norm.X=1;
            else
            norm.X=-1;
            itBalles->collision(norm);
            }
            else
            {
            itBalles->stop();
            }
            */
            // 05/12
            //solution oldschool, decomposition du mouvement
            
            if(!itBalles->isTraversante())
            {
              itBalles->undoDeplacer();
              itBalles->avanceX();
              //se deplacer sur X suffit a toucher
              if (eventCollision
                  (*(niveauCourant.tabBriques[i][j]),
                   *itBalles))
              {
                itBalles->reculeX();
                itBalles->avanceY();
                
                //collision quel que soit le deplacement, evite des blocages
                if(eventCollision  
                   (*(niveauCourant.tabBriques[i][j]),
                    *itBalles))
                {
                  itBalles->reculeY();
                  itBalles->rebondY();
                }
                itBalles->rebondX();
              }
              else //peut etre sur Y alors?
              {
                itBalles->reculeX();
                itBalles->avanceY();
                if (eventCollision
                    (*(niveauCourant.tabBriques[i][j]),
                     *itBalles))
                {
                  itBalles->reculeY();
                  itBalles->rebondY();
                }
                else //en fait non, les 2 a la fois, tant pis
                {
                  itBalles->reculeY();
                  itBalles->rebondX();
                  itBalles->rebondY();
                }
              }
              amixer.SPlay_BrickHit();
            }
            itBalles->getProp()->ajouterScore(itBalles->getIRayon());
            
            //// degats sur la brique ////
            if(niveauCourant.tabBriques[i][j]->faireDegats(itBalles->getIRayon ())) 
            {
              Vecteur *position = niveauCourant.tabBriques[i][j]->getPosition();
              
              //creation du bonus
              //if(rand() %10 <= 2)
              newBonus(position->X,position->Y, -1);
              
              //creation des debris
              for(newDebris = (rand() % 10) + 5; newDebris > 0; newDebris--)
                listeDebris.push_back (*new Debris(*position));
              
              //suppression de la brique
              detruireBrique(i,j);
              amixer.SPlay_BrickDestroy();
            }
          }
        }
      }
    }
    
    //// test de collision avec les battes (il n'y en a qu'une) ////
    if(!joueur1.isDestroyed())
    {
      if (itBalles->isGoingDown() && eventCollision (*itBalles, joueur1.getBatteRef()))
      {
        // 04/12: passage au rebond proportionnel
        /*
        //rebond simple, type surface plane
        norm.X = ((*itBalles).getPosition()->X) - (joueur1.getBatteRef().getPosition()->X);
        norm.Y = 12;
        if(fabs(norm.X) < 0.0001)
        norm.X=0;
        
        //std::cout << "collision: " << norm.X << " " << norm.Y << std::endl;
        tmp = sqrt( powf(norm.X,2) + powf(norm.Y,2) );
        norm.X = norm.X / tmp;
        norm.Y = norm.Y / tmp;
        
        norm.Z=0;
        */
        
        ////// rebond proportionnel a l'offset de la frappe ////////
        
        const float angleRebond = 1.57 ; //ouverture de l'angle des rebonds
        angle = angleRebond * (itBalles->getPosition()->X - joueur1.getBatteRef().getPosition()->X)
          / joueur1.getBatteRef().getLongueur();
        
        itBalles->undoDeplacer();
        itBalles->rebondBatte(angle);
        amixer.SPlay_PlayerHit();
      }
    }
    
    //collisions entre les balles ()
    //extremement gourmand en ressources et chiant a jouer
    /*
    std::list < Balle >::iterator iBalles;
    Vecteur bdiffPosition;
    float distance;
    iBalles = itBalles;
    for(iBalles++ ; iBalles != listeBalles.end() ; iBalles++)
    {
      bdiffPosition = *itBalles->getPosition() - *iBalles->getPosition();
      distance = sqrt( powf(bdiffPosition.X,2) + powf(bdiffPosition.Y,2));
      if( distance < itBalles->getRayon() + iBalles-> getRayon())   //securite pour eviter le blocage
      {
        itBalles->deplacer(bdiffPosition);
        iBalles->deplacer(-bdiffPosition);
        
        bdiffPosition.normalize(distance);
        
        itBalles->collision(bdiffPosition);      
        iBalles->collision(-bdiffPosition);
      }
    } 
    */
    
    //sortie de la balle
    itrmBalles = itBalles;
    itBalles++;
    if(itrmBalles->getPosition()->Y < -40)
    {
      listeBalles.erase(itrmBalles);
      joueur1.rmBalle();
      
      //plus de balles? bing
      if(joueur1.getnBalles() == 0)
      {
        Vecteur &position = *(joueur1.getBatteRef().getPosition());
        float pas;
        int nombreDebris=25;
        
        joueur1.destroy();
        amixer.SPlay_PlayerDestroy();
        
        position.X = position.X + joueur1.getBatteRef().getLongueur()/2;
        pas = joueur1.getBatteRef().getLongueur() / nombreDebris;
        //creation des debris
        for(newDebris = nombreDebris; newDebris > 0; newDebris--)
        {
          listeDebris.push_back (*new Debris(position,0,255,0));
          position.X -=pas;
        }
        
      }
    }
  }
  
  //std::cout << " gestion des bonus" << std::endl;
  //test de collision entre un bonus et la batte
  //Batte joueur 1 (il n'y a qu'un joueur)
  if(!joueur1.isDestroyed())
  {
    std::list < Balle >::iterator iBalles;
    for(itBonus = listeBonus.begin() ; itBonus != listeBonus.end() ;)
    {
      itrmBonus = itBonus;
      itBonus++;
      if(eventCollision(*itrmBonus,joueur1.getBatteRef()))
      {
        //effets du bonus
        switch(itrmBonus->getType())
        {
          case BONUS_RBATTE:
            joueur1.getBatteRef().reduire();
          break;
          case BONUS_ABATTE:
            joueur1.getBatteRef().agrandir();
          break;
          case BONUS_LIFE:
            joueur1.ajouterVie();
          break; 
          case BONUS_MULTIBALL:
            newBall(&joueur1,false);
          break;
          case BONUS_BTRAVERSANTE:
            for(iBalles = listeBalles.begin() ; iBalles != listeBalles.end() ;iBalles++)
          {
            iBalles->setTraversante();
          }
          break;
          case BONUS_ARME:
            joueur1.getBatteRef().putCanon();
          break;
          case BONUS_ABALLE:
            for(iBalles = listeBalles.begin() ; iBalles != listeBalles.end() ;iBalles++)
          {
            iBalles->agrandir();
          }
          break;
          default:
            std::cout << " bonus en bois" << std::endl;
          break;
        }
        //destruction du bonus
        listeBonus.erase(itrmBonus);
        
        //points bonus
        joueur1.ajouterScore(5);
        
      }
      else if (itrmBonus->getPosition()->Y < -40)
      {
        //destruction du bonus
        listeBonus.erase(itrmBonus);
      }
    }
  }
}



Coop2j::Coop2j ():Partie (2, 0, COTE_BAS, COTE_BAS)
{
}

void
Coop2j::verifPositions ()
{
}
